//+------------------------------------------------------------------+
//|                                                  Import test.mq5 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"



//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
#import "Ws2_32.dll"
   int WSAStartup(ushort wVersionRequested, char& lpWSAData[]);
   int WSACleanup();
   int WSAGetLastError();
    
   int socket(int af, int type, int protocol);
   int shutdown(int socket);
   int closesocket(int socket);
   
   int bind(int socket, char& lpSockAddr[], int size);
   int listen(int socket, int maxClients);
   int accept(int socket, int a=0, int b=0);
   int recv(int socket, char& lpBuffer[], int bufferLen, int flags);
   
   int inet_ntoa(uint addr);
   ushort ntohs(ushort number);
   ushort htons(ushort number);  
#import

#define PF_INET 2
#define SOCK_STREAM 1
#define IPPROTO_TCP 6

#define WSADESCRIPTION_LEN 256
#define WSASYS_STATUS_LEN  128

#define INVALID_SOCKET ((int)(~0))
#define SOCKET_ERROR (-1)

#define MAX_CLIENTS 10

struct WSAData
{
   ushort   wVersion;
   ushort   wHightVersion;
   uchar    iMaxSockets;
   uchar    iMaxUdpDg;
   int      lpVendorInfo;
   char     szDescription[ WSADESCRIPTION_LEN+1 ];
   char     szSystemStatus[ WSASYS_STATUS_LEN+1 ];
};

#define WSADATA_LEN (2+2+1+1+4+1+1)

//struct IN_ADDR
//{
//   uchar net;
//   uchar host;
//   uchar logicalHost;
//   uchar imp;   
//};
#define IN_ADDR uint
#define INADDR_ANY (uint)0x00000000

struct SOCKADDR_IN
{
   ushort   Family;
   ushort   Port;
   IN_ADDR  Addr;
   char     Zero[8];
};
struct SOCKADDR_IN_REF
{
   char ref[2+2+4+8];
};

#import "msvcrt.dll"
   //int memcpy(ulong& dst, ulong& src, int cnt);
   int memcpy(char& dst[], char& src[], int cnt);
   //int memcpy(int& dst[], int& src[], int cnt);
   //int memcpy(char& src[], int lpDst, int cnt);
#import


void ErrorLog(string functionName, int errno)
{
   Print("\"", functionName, "()\" has failure with error code: ", errno, " see winsock erorr codes");
}

int ArrayPointer(char& array[])
{
   return memcpy(array, array, 0);
}

ushort MkWord(uchar hight, uchar low)
{
   return ( (hight << 8) | low );
}


void OnStart()
{

   // dll initialization
   ushort wVersionRequested = MkWord(2, 2);
   char wsaData[WSADATA_LEN];
   int errno = WSAStartup(wVersionRequested, wsaData);
   if (errno != 0)
   {
      ErrorLog("WSAStartup", WSAGetLastError());
      WSACleanup();
      return;
   }
   
   
   // make listen socket
   int serverSocket = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
   if (INVALID_SOCKET == serverSocket)
   {
      ErrorLog("socket", WSAGetLastError());
      WSACleanup();
      return;
   }

   
   // bind to port
   SOCKADDR_IN sin;
   sin.Family = PF_INET;
   ushort portNumber = 13313;
   Print("Bind to port ", portNumber);
   sin.Port = htons(portNumber);
   sin.Addr = INADDR_ANY;
   SOCKADDR_IN_REF lpSin = (SOCKADDR_IN_REF)sin;

   errno = bind(serverSocket, lpSin.ref, sizeof(sin));
   if (0 != errno)
   {
      ErrorLog("bind", WSAGetLastError());
      closesocket(serverSocket);
      WSACleanup();
      return;
   }
   
   errno = listen(serverSocket, 1);
   if (0 != errno)
   {
      ErrorLog("listen", WSAGetLastError());
      closesocket(serverSocket);
      WSACleanup();
      return;
   }

   // wait for incoming connection
   int clientSocket = accept(serverSocket, 0, 0);
   if (INVALID_SOCKET == clientSocket)
   {
      ErrorLog("accept", WSAGetLastError());
      closesocket(serverSocket);
      WSACleanup();
      return;
   }
   
   #define RCVBUFFSIZE 1024
   char rcvBuffer[RCVBUFFSIZE];

   // wait for incoming data
   int bytesCnt = recv(clientSocket, rcvBuffer, RCVBUFFSIZE, 0);
   if (0 < bytesCnt)
   {
      Print("Received ", bytesCnt, " bytes");
   }
   else if (0 == bytesCnt)
   {
      Print("Connection closed");
   }
   else
   {
      ErrorLog("recv", WSAGetLastError());
   }
   
     
   // dll clenup
   closesocket(clientSocket);
   closesocket(serverSocket);   
   WSACleanup();
}
  

//+------------------------------------------------------------------+
// vim:syntax=c